; Animation routines
; by David Phillips <david@acz.org>
; Assembly Coder's Zenith -- http://www.acz.org/
;
; sprites are masked sprites
;============================================================================

ANIMTIME = 4
ANIMSIZE = 20

ClearAnims:
 ld hl,Anims
 ld de,Anims+1
 ld bc,(ANIMSIZE*6)-1
 ld (hl),0
 ldir
 ret

UpdateAnims:
 ld hl,Anims
 ld b,ANIMSIZE
UpdateAnimL:
 ld a,(hl)				; frames
 or a
 jr z,UpdateAnimS
 push bc
 inc hl					; time
 dec (hl)
 jr nz,UpdateAnimC
 ld (hl),ANIMTIME
 dec hl					; frames
 dec (hl)
 jr z,UpdateAnimQ
 inc hl					; time
 inc hl					; spriteptr.l
 ld e,(hl)
 inc hl					; spriteptr.h
 ld d,(hl)
 ex de,hl
 ld bc,24
 add hl,bc
 ex de,hl
 ld (hl),d
 dec hl					; spriteptr.l
 ld (hl),e
 inc hl					; spriteptr.h
 inc hl					; coords.y
 jr UpdateAnimG
UpdateAnimC:
 inc hl					; spriteptr.l
 ld e,(hl)
 inc hl					; spriteptr.h
 ld d,(hl)
 inc hl					; coords.y
UpdateAnimG:
 ld c,(hl)
 inc hl					; coords.x
 ld b,(hl)
 inc hl					; frames (next)
 push hl
 ex de,hl
 call GraySpriteClip  
 pop hl
 pop bc
 djnz UpdateAnimL
 jr UpdateAnimS
UpdateAnimQ:
 pop de
UpdateAnimS:
 ld de,6
 add hl,de				; frames (next)
 djnz UpdateAnimL
 ret

; hl = starting sprite pointer, de = coords, c = frames
AddAnim:
 push de
 push hl
 ld hl,Anims
 ld b,ANIMSIZE-1
 ld de,6
AddAnimL:
 sub a
 or (hl)
 jr z,AddAnimF  
 add hl,de
 djnz AddAnimL
 pop hl
 pop de
 ret
AddAnimF:
 ld (hl),c
 inc hl
 ld (hl),ANIMTIME
 inc hl  
 pop de
 ld (hl),e
 inc hl 
 ld (hl),d
 inc hl
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
 ret
