; Item routines

; heart = 1
; rupee = 2
; bomb = 3

MAXITEMS = 10

;====================================================================

ClearItems:
 ld hl,Items
 ld de,Items+1
 ld bc,(MAXITEMS*3)-1
 ld (hl),0
 ldir
 ret

; in: bc = coords, a = item num
AddItem:
 ld d,MAXITEMS
 ld e,a
 ld hl,Items
AddItemL:
 ld a,(hl)
 or a
 jr z,AddItemF
 inc hl
 inc hl
 inc hl   
 dec d
 jr nz,AddItemL
 ret
AddItemF:
 ld (hl),e
 inc hl
 ld (hl),c
 inc hl
 ld (hl),b
 ret

; in: bc = coords
PlaceRandomItem:
 push bc
 call RandomNumber
 pop bc
 ld hl,AddItem
 push hl
 cp 8
 jr nc,PlaceRandomItemNext
 ld a,1
 ret
PlaceRandomItemNext:
 cp 14
 jr nc,PlaceRandomItemNext2
 ld a,(PlayerItems)
 cp 3
 jr c,PlaceRandomItemRupee
 ld a,3
 ret
PlaceRandomItemNext2:
 cp 28
 jr nc,PlaceRandomItemNext3
PlaceRandomItemRupee:
 ld a,2
 ret
PlaceRandomItemNext3:
 pop hl
 ret

UpdateItems:
 ld hl,Items
 ld b,MAXITEMS
UpdateItemsL:
 ld a,(hl)
 or a
 jr nz,UpdateItemA
 inc hl
 inc hl
 inc hl
UpdateItemsE:
 djnz UpdateItemsL
 ret
UpdateItemA:
 push bc
 ld a,(hl) 
 inc hl
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 push hl
 push af
 push bc
 call TryGivePlayerItem
 pop bc
 pop af
 dec a
 add a,a
 add a,a
 add a,a
 ld d,a
 add a,a
 add a,d
 ld l,a
 ld h,0
 ld de,ItemSpr
 add hl,de
 call GraySpriteClip
 pop hl
 pop bc
 jr UpdateItemsE

; in: a = item num, bc = coords
TryGivePlayerItem:
 ld de,(PlayerY)
 ld (_@GivePlayerItemI),a
 call CheckCollision
 ret c
GivePlayerItem:
 dec hl
 dec hl
 dec hl
 ld (hl),0
 ld a,0
_@GivePlayerItemI =$-1
 dec a
 jr z,GivePlayerHeart
 dec a
 jr z,GivePlayerRupee
 dec a
 jr z,GivePlayerBomb
 ret

GivePlayerHeart:
 ld hl,PlayerLife
 ld a,(PlayerMaxLife)
 ld c,a
 sub (hl)
 ret z
 inc (hl)
 ld a,c
 sub (hl)
 ret z
 inc (hl) 
 ret

GivePlayerRupee:
 ld hl,(PlayerRupees)
 inc hl
 ld (PlayerRupees),hl 
 ret

; a = number of rupees
GivePlayerRupees:
 ld hl,(PlayerRupees)
 ld d,0
 ld e,a 
 add hl,de
 ld (PlayerRupees),hl
 ret

GivePlayerBomb:
 ld hl,PlayerBombs
 inc (hl)
 ret 

ItemSpr:

HeartSpr:
	.db %00000000
	.db %00101000
	.db %01111100
	.db %01101100
	.db %00111000
	.db %00010000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00101000
	.db %01010100
	.db %01010100
	.db %00101000
	.db %00010000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00101000
	.db %01111100
	.db %01111100
	.db %00111000
	.db %00010000
	.db %00000000
	.db %00000000

RupeeSpr:
	.db %00010000
	.db %00111000
	.db %01101100
	.db %01110100
	.db %01110100
	.db %01101100
	.db %00111000
	.db %00010000
	.db %00010000
	.db %00101000
	.db %01010100
	.db %01001100
	.db %01001100
	.db %01010100
	.db %00101000
	.db %00010000
	.db %00010000
	.db %00111000
	.db %01111100
	.db %01111100
	.db %01111100
	.db %01111100
	.db %00111000
	.db %00010000

BombItemSpr:
	.db %00000000
	.db %00001100
	.db %00010010
	.db %00111000
	.db %01100100
	.db %01110100
	.db %01111100
	.db %00111000
	.db %00000000
	.db %00001100
	.db %00010010
	.db %00111000
	.db %01010100
	.db %01101100
	.db %01110100
	.db %00111000
	.db %00000000
	.db %00001100
	.db %00010010
	.db %00111000
	.db %01111100
	.db %01111100
	.db %01111100
	.db %00111000

.end
