; Link's routines

; these sort of suck, since I wrote them all at different times and
; probably lots of this could be worked out into better routines, but I'm
; too lazy to fix it ;-)

PFLASHTIME      = 40        ; length of invincibility when hurt

SWORDCHARGE     = 30
BOMBTIME        = 50
BOOMERANGTIME   = 30

#include "items.asm"

;====================================================================
; a = direction attack is from (shield blocks if able)
HurtPlayerDir:
 ld hl,HurtPlayerDirTable
 ld d,0
 ld e,a
 add hl,de
 ld a,(PlayerDir)
 cp (hl)
 jr nz,HurtPlayer
 ld a,(_@DrawPlayerShieldTest)
 or a
 ret nz
HurtPlayer:
 ld hl,PlayerFlash
 ld a,(hl)
 or a
 ret nz
 ld (hl),PFLASHTIME
 ld hl,PlayerLife
 ld a,(hl)
 dec a
 ld (hl),a
 ret

; opposite directions for fast testing
HurtPlayerDirTable:
 .db 1, 0, 3, 2

; in: bc = coords
; out: bad coords = carry set
GetTileCentClip:
 ld a,b
 cp -7
 ret nc
 ld a,c
 cp -7
 ret nc
 ld a,124
 cp b
 ret c
 ld a,60
 cp c
 ret

; in: bc = coords
; out: bad coords = carry set
CheckCoords:
 ld a,b
 cp -7
 ret nc
 ld a,c
 cp -7
 ret nc
 ld a,127
 cp b
 ret c
 ld a,62
 cp c
 ret

;====================================================================
UpdateWeapons:
 call UpdateSword
 call UpdateBomb
 call UpdateBoomerang
 jp UpdateArrow

ClearWeapons:
 sub a
 ld (PlayerSwordF),a
 ld (PlayerBomb),a
 ld (PlayerBoomerT),a
 inc a
 ld (_@DrawPlayerShieldTest),a
 ld a,-1
 ld (PlayerArrowDir),a 
 ret

;====================================================================
UpdateSword:
 ld hl,PlayerSwordF
 ld a,(hl)
 or a
 jr nz,UpdateSwordOk    ; frame = 0
 inc a
 ld (_@DrawPlayerShieldTest),a
 ret
UpdateSwordOk:
 dec (hl)
 ld a,(hl)
 push af
 dec hl
 ld c,(hl)
 ld de,SwordSpr
 jr z,UpdateSwordFlash  ; frame = 0
 and %00000001
UpdateSwordNoFlash:
 ld a,c
 jr nz,UpdateSwordSkip  ; frame is odd
 dec (hl)
 ld b,a
 ld a,%00000111
 and (hl)
 ld (hl),a
 ld a,b
 jr UpdateSwordSkip
UpdateSwordFlash:
 ld a,(ButtonA)
 cp SWORDCHARGE
 jr c,UpdateSwordNoFlash
 ld de,SwordSprFlash
 ld a,c
 rra
UpdateSwordSkip:
 add a,a
 ex de,hl
 add a,a
 add a,a
 ld e,a
 add a,a
 add a,e
 ld e,a
 ld d,0
 add hl,de              ; hl = sprite
 push hl
 ld a,c
 add a,c
 ld e,a
 ld d,0
 ld hl,SwordDrawLoc
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld hl,(PlayerY)
 add hl,de
 ld b,h
 ld c,l                 ; bc = draw location
 pop hl
 push bc
 call CheckCoords
 call nc,GraySpriteClip
 pop bc
SwordCheck:
 pop af
 and %00000001
 ret nz
 push bc
 call CheckPlant
 pop bc 
SwordCheckEnemies:
 ld a,1
 call DamageEnemies
 ret nc
 ld a,1
 ld (_@HoldButtonACheck),a
 ret

; returns: carry set = no collision
CheckPlant:
 call GetTileCentClip
 ret c
 call GetTileCent
 ex de,hl
 sub a
 ld (_@CheckPlantItem),a
 ld a,(hl)
CheckPlantA:
 cp PLANT
 jr nz,CheckPlantHole
 ld (hl),0
 jr CheckPlantHit
CheckPlantHole:
 ld (_@CheckPlantItem),a
 cp PLANTHOLE
 jr nz,CheckPlantCave
 ld (hl),HOLE
 jr CheckPlantHit
CheckPlantCave:
 cp PLANTCAVE
 scf
 ret nz
 ld (hl),LADDERCAVE
CheckPlantHit:
 ld (RedrawMap),a
 call GetCoords
 ld d,b
 ld e,c
 ld hl,PlantChopAnim
 push bc
 ld c,5
 call AddAnim
 pop bc
_@CheckPlantItem =$+1
 ld a,0
 or a
 jp z,PlaceRandomItem
 ret

; amount to add to coords for each direction (y, x)
SwordDrawLoc:
 .db -8,0, -8,-8, 0,-8, 8,-8, 8,0, 8,8, 0,8, -8,8

ChargeSword:
 ld a,8<<1
 ld (PlayerSwordF),a
 ld hl,PlayerSwordDir
 dec (hl)
 ld a,%00000111
 and (hl)
 ld (hl),a
 ret

SwingSword:
 ld b,3<<1

; b = frames to attack
AttackSword:
 ld hl,PlayerSwordF
 ld a,(hl)
 or a
 ret nz
 ld (hl),b
 dec hl
 ld a,(PlayerDir)
 ld (hl),2
 or a
 ret z
 ld (hl),6
 dec a
 ret z
 ld (hl),4
 dec a
 ret z
 ld (hl),0
 ret

;====================================================================
UpdateBomb:
 ld hl,PlayerBomb
 xor a
 or (hl)
 ret z
 dec (hl)
 jr z,UpdateBombBlow
 ld bc,(PlayerBombY)
 call CheckCoords
 jr c,UpdateBombBlow
 bit 0,(hl)
 jr z,UpdateBombSpr2
 ld hl,BombSpr
 jp GraySpriteClip
UpdateBombSpr2:
 ld hl,BombGlowSpr2
 jp GraySpriteClip 
UpdateBombBlow:
 ld ix,BombBlowAnim-72
 ld hl,BombExpDrawLoc
 ld bc,$0903
UpdateBombBlowL:
 push bc
 ld d,(hl)
 inc hl
 ld e,(hl)
 inc hl
 push hl
 ld hl,(PlayerBombY)
 add hl,de              ; hl = coords, de = offset
 push bc
 ld b,h
 ld c,l
 call CheckCoords
 pop bc
 jr c,UpdateBombBlowS
 push hl
 ld de,72
 add ix,de
 ex de,hl
 push ix
 pop hl                 ; hl = spr, de = coords, bc = stuff 
 call AddAnim
 pop bc
 call GetTileCentClip
 jr c,UpdateBombBlowS
 push bc 
 call GetTileCent
 ex de,hl
 ld a,(hl)
 cp BOMBABLEC
 jr nz,UpdateBombBlowRange
 ld (hl),CAVE
 ld (RedrawMap),a
 jr UpdateBombBlowD
UpdateBombBlowRange:
 cp BOMBABLE_START
 jr c,UpdateBombBlowD
 cp BOMBABLE_END+1
 jr nc,UpdateBombBlowD 
 ld (hl),0
 ld (RedrawMap),a
UpdateBombBlowD:
 call CheckPlantA
 pop bc
 ld a,3
 call DamageEnemies
UpdateBombBlowS:
 pop hl
 pop bc
 djnz UpdateBombBlowL
 ret

DropBomb:
 ld hl,PlayerBomb
 sub a
 or (hl)
 ret nz
 ld bc,(PlayerY)
 call CheckCoords
 ret c  
 ld de,PlayerBombs
 ld a,(de)
 or a
 ret z
 dec a
 ld (de),a
 ld (hl),BOMBTIME
 ld a,(PlayerDir)
 add a,a
 ld e,a
 ld d,0
 ld hl,BombDropLoc
 add hl,de
 ld a,(hl)
 inc hl
 ld l,(hl)
 ld h,a
 ld de,(PlayerY)
 add hl,de
 ld (PlayerBombY),hl    
 ret

BombDropLoc:
 .db 0,-8, 0,8, -8,0, 8,0

; left to right, top to bottom
; the first three are weird...
BombExpDrawLoc:
 .db -9,-8, -1,-8, 7,-8,  -8,0, 0,0, 8,0,  -8,8, 0,8, 8,8
 
;====================================================================
ThrowBoomerang:
 ld hl,PlayerBoomerT
 sub a
 or (hl)
 ret nz
 inc (hl)
 inc hl                     ; PlayerBoomerDir
 ld (hl),0
 ld a,(PlayerDir)
 ld e,a
 ld d,0
 ld ix,BoomerangTable
 add ix,de
 ld a,(ix)
 ld (hl),a
 inc hl                     ; PlayerBoomerY
 ld a,(PlayerY)
 add a,(ix+4)
 ld (hl),a
 inc hl                     ; PlayerBoomerX
 ld a,(PlayerX)
 add a,(ix+8)
 ld (hl),a
 ret

UpdateBoomerang:
 ld hl,PlayerBoomerT
 ld a,(hl)
 or a
 ret z
 ld bc,(PlayerBoomerY) 
 rla
 jr c,UpdateBoomReturn
 inc (hl)
 ld a,BOOMERANGTIME
 cp (hl)
 jr z,UpdateBoomSetReturn
 ld a,-8
 cp b
 jr c,UpdateBoomSetRetLeft
 ld a,121
 cp b
 jr c,UpdateBoomSetReturn
 ld a,-8
 cp c
 jr c,UpdateBoomSetRetUp
 ld a,57
 cp c
 jr c,UpdateBoomSetReturn
UpdateBoomMove:             ; this probably ought to be a table...
 ld a,(PlayerBoomerDir)     ; but I'm too lazy because it works :)
 rra
 jr c,UpdateBoomUp
 rra
 jr c,UpdateBoomDown
 rra
 jr c,UpdateBoomLeft
UpdateBoomRight:
 inc b
 inc b 
 jr UpdateBoomMoved   
UpdateBoomLeft:
 dec b
 dec b
 jr UpdateBoomMoved
UpdateBoomDown:
 inc c
 inc c
 jr UpdateBoomMoved
UpdateBoomUp:
 dec c
 dec c
UpdateBoomMoved:
 ld (PlayerBoomerY),bc
UpdateBoomDraw:
 ld a,(PlayerBoomerT)
 and %00001100
 rla
 ld e,a
 rla
 add a,e
 ld e,a
 ld d,0
 ld hl,BoomerangSpr
 add hl,de
 push bc
 call GraySpriteClip
 pop bc
 push bc 
 call CheckPlant
 pop bc
 jr nc,UpdateBoomerFlip
 ld a,1
 call DamageEnemies
 ret nc
UpdateBoomerFlip:
 ld hl,PlayerBoomerT
 ld a,%10000000
 xor (hl)
 ld (hl),a
 ret
UpdateBoomSetRetUp:
 ld a,1
 ld (PlayerBoomerY),a
 jr UpdateBoomSetReturn
UpdateBoomSetRetLeft:
 ld a,1
 ld (PlayerBoomerX),a 
UpdateBoomSetReturn:
 set 7,(hl)
UpdateBoomReturn:
 dec (hl)
 jp m,UpdateBoomRetOk
 ld (hl),0
 ret
UpdateBoomRetOk:
 inc hl                 ; PlayerBoomDir
 inc hl                 ; PlayerBoomY
 ld bc,(PlayerY)
 ld a,(hl)
 cp c
 jr z,UpdateBoomRetYdone
 jr c,UpdateBoomRetYmore
 ld a,-2
 jr UpdateBoomRetY
UpdateBoomRetYmore:
 ld a,2
UpdateBoomRetY:
 add a,(hl)
 ld (hl),a
UpdateBoomRetYdone:
 inc hl                 ; PlayerBoomX
 ld a,(hl)
 cp b
 jr z,UpdateBoomRetDone
 jr c,UpdateBoomRetXmore
 ld a,-2
 jr UpdateBoomRetX
UpdateBoomRetXmore:
 ld a,2
UpdateBoomRetX:
 add a,(hl)
 ld (hl),a
UpdateBoomRetDone:
 ld bc,(PlayerBoomerY) 
 jr UpdateBoomDraw 

; bits for direction
; offset for drop location (y's, then x's)
BoomerangTable:
 .db %00000001, %00000010, %00000100, %00001000
 .db -8, 8, 0, 0
 .db 0, 0, -8, 8

;====================================================================
ShootArrow:
 ld a,(PlayerArrowDir)
 inc a
 ret nz
 ld hl,PlayerArrows
 sub a
 or (hl)
 ret z
 dec (hl)
 ld a,(PlayerDir)
 ld (PlayerArrowDir),a
 add a,a
 ld hl,ProjectileOffsetTable
 ld d,0
 ld e,a
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ld hl,(PlayerY)
 add hl,de
 ld (PlayerArrowY),hl
 ret

UpdateArrow:
 ld a,(PlayerArrowDir)
 cp -1
 ret z
 ld hl,DirTableCoords2
 add a,a
 ld d,0
 ld e,a
 add hl,de
 ld a,(PlayerArrowX)
 add a,(hl)
 ld b,a
 inc hl
 ld a,(PlayerArrowY)
 add a,(hl)
 ld c,a
 ld (PlayerArrowY),bc
 call GetTileCentClip
 jr c,UpdateArrowStop
 push bc
 ld a,2
 call DamageEnemiesPoint
 pop bc
 jr c,UpdateArrowStop
UpdateArrowDraw:
 ld a,(PlayerArrowDir)
 add a,a
 add a,a
 add a,a
 add a,a
 ld e,a
 add a,a
 add a,e
 ld e,a
 ld a,(Frame)
 and %00000001
 add a,a
 add a,a
 add a,a
 add a,e
 ld e,a
 ld hl,ArrowSpr
 add hl,de
 call GraySpriteClip
 ret
UpdateArrowStop:
 ld a,-1
 ld (PlayerArrowDir),a
 ret

  
.end
