; Text routines

; hl = pointer to text
PrintText:
 push hl                            ; all this junk just to draw a nifty border :)
 ld hl,GrayMem1+((128*3)-48)
 ld de,GrayMem1+((128*3)-48)+1
 ld bc,31
 ld (hl),%01010101
 ldir
 inc hl
 inc de
 ld bc,((128*2)+16)-1
 ld (hl),0
 ldir
 inc hl
 inc de
 ld bc,31
 ld (hl),%10101010
 ldir
 ld hl,GrayMem2+((128*3)-48)
 ld de,GrayMem2+((128*3)-48)+1
 ld bc,31
 ld (hl),%01010101
 ldir
 inc hl
 inc de
 ld bc,((128*2)+16)-1
 ld (hl),0
 ldir
 inc hl
 inc de
 ld bc,31
 ld (hl),%10101010
 ldir
 pop hl

DoPrintText:
 ld bc,0
DoPrintTextLoop:
 push bc 
 call PrintTextLine
 pop bc
 or a
 jp z,Pause
 dec a
 jr nz,TextAsk
 bit 7,c
 jr z,DoPrintTextNext
 call Pause
 push hl
 push bc
 call ScrollText
 pop bc
 pop hl
DoPrintTextNext:
 ld c,128
 jr DoPrintTextLoop

; carry set = yes
TextAsk:
 ld hl,TextYesNo
 call PrintTextLine
TextAskNo:
 ld bc,128+6
 ld a,' '
 call PrintChar
 ld bc,128+1
 ld a,$2b
 call PrintChar
 call ShowGray
TextAskNoLoop:
 halt
 call _get_key
 cp K_RIGHT
 jr z,TextAskYes
 cp K_DOWN
 jr z,TextAskYes
 cp K_SECOND
 jr nz,TextAskNoLoop
 ret
TextAskYes: 
 ld bc,128+1
 ld a,' '
 call PrintChar
 ld bc,128+6
 ld a,$2b
 call PrintChar
 call ShowGray
TextAskYesLoop:
 halt
 call _get_key
 cp K_LEFT
 jr z,TextAskNo
 cp K_UP
 jr z,TextAskNo
 cp K_SECOND
 jr nz,TextAskYesLoop
 scf 
 ret 
 
TextYesNo:
 .db "  No   Yes",0

; hl = text, bc = offset in buffer
PrintTextLine:
 ld a,(hl)
 inc hl 
 cp 3
 ret c
 push hl
 push bc
 call PrintChar
 call ShowGray
 ld b,15
PrintTextLineDelay:
 halt
 djnz PrintTextLineDelay 
 pop bc
 inc bc
 pop hl
 jr PrintTextLine

; hl = string, bc = correct offset on screen-384 bytes
PrintTextString:
 ld a,(hl)
 inc hl 
 or a
 ret z
 push hl
 push bc
 call PrintChar
 pop bc
 inc bc
 pop hl
 jr PrintTextString

; a = char to print, bc = offset in buffer
PrintChar:
 add a,a
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 ld ix,TextFont-(' '*8)
 ex de,hl
 add ix,de
 ld hl,GrayMem2+(128*3)
 add hl,bc
 ex de,hl
 ld hl,GrayMem1+(128*3)
 add hl,bc
 ld bc,16
 ld a,8
PrintCharLoop:
 ld (_@PrintCharLoopC),a
 ld a,(ix+0)
 inc ix
 ld (hl),a
 add hl,bc
 ex de,hl
 ld (hl),a
 add hl,bc
 ex de,hl
_@PrintCharLoopC =$+1
 ld a,0
 dec a
 jr nz,PrintCharLoop
 ret

ScrollText:
 ld hl,GrayMem1+(128*4)
 ld de,GrayMem1+(128*3)
 ld bc,128
 ldir
 ex de,hl
 ld de,GrayMem1+(128*4)+1
 ld (hl),0
 ld c,127
 ldir
 ld hl,GrayMem2+(128*4)
 ld de,GrayMem2+(128*3)
 ld bc,128
 ldir
 ex de,hl
 ld de,GrayMem2+(128*4)+1
 ld (hl),0
 ld c,127
 ldir
 ret  

; a = string number to print
PrintString:
 ld hl,TextStrings
 or a
 ld d,a
PrintStringL:
 jp z,PrintText
 sub a
 ld b,a
 ld c,a
 cpir
 dec d
 jr PrintStringL

.end
