; Tile Object routines
; by David Phillips <david@acz.org>
; Assembly Coder's Zenith -- http://www.acz.org/

;============================================================================

MapVar:
 .db 4,"maps"

; this routine really sucks!!!
; a = map number to load
; copies map and loads info
LoadMapNum:
 ld (CurrMap),a				; must be set by this routine
 ld hl,(PlayerY)			; entry coords saved so map can be restarted
 ld (CurrMapEnterCoords),hl
 ld hl,MapVar-1
 rst 20h
 rst 10h
 call _ex_ahl_bde 
 call _ahl_plus_2_pg3
 push af
 push hl
 call _inc_ptr_ahl			; skip the NumMaps byte
 call _ahl_plus_2_pg3		; skip ChestList pointer
 push af
 push hl
 ld c,a
 call _ram_page_1
 ld a,(CurrMap)
 ld d,a
 ld e,0
 srl d
 rr e
 add hl,de					; it's multiplied by 128 (map size) and added to start+1
 ld a,c
 adc a,0
 ld b,a
 ld d,0
 ld a,(NumMaps)				; load number of maps, and multiply by 2, to skip the MapInfo pointer table
 add a,a
 rl d
 ld e,a
 add hl,de
 ld a,b
 adc a,0
 call _set_abs_src_addr
 ld hl,Map-$8000			; the 128 byte map is copied to Map
 ld a,1
 call _set_abs_dest_addr
 sub a
 ld hl,128
 call _set_mm_num_bytes
 call _mm_ldir

LoadMapInfo:
 call _ram_page_1
 pop hl						; back at very start
 ld d,0
 ld a,(CurrMap)				; map number is multiplied by 2 to get map info pointer from table
 add a,a
 rl d
 ld e,a  
 pop af
 add hl,de					; added to start to get correct map info pointer
 adc a,0
 call _get_word_ahl
 pop hl
 pop af
 add hl,de					; add to start to get map info entry
 adc a,0 
 call _set_abs_src_addr
 ld hl,Temp-$8000			; it is copied to Temp so an easy routine can work with it
 ld a,1
 call _set_abs_dest_addr
 sub a
 ld hl,100
 call _set_mm_num_bytes
 call _mm_ldir
 call _ram_page_1

 call ClearAnims
 call ClearWeapons
 call ClearItems
 call ClearEnemies
 call ClearEnemyProj
 call ClearChests
 call ChangeListFixMap 

 ld hl,Temp
LoadMapInfoEdge:
 ld bc,4
 ld de,MapIUp
 ldir
LoadMapInfoWarp:
 ld a,(hl)
 inc hl
 or a
 jr z,LoadMapInfoWarpF
 ld c,a
 ldir
LoadMapInfoWarpF:
 push hl
 cpl
 add a,16
 ld c,a
 ld h,d
 ld l,e
 inc de
 ld (hl),$ff
 ldir
 pop hl
LoadMapInfoPeople:
 ld a,(hl)
 inc hl
 or a
 jr z,LoadMapInfoEnemy
 ld c,a
 ld de,People
 ldir
 push hl
 cpl
 add a,8
 ld c,a
 ld h,d
 ld l,e
 inc de
 ld (hl),$ff
 ldir
 pop hl 
LoadMapInfoEnemy:
 ld a,(hl)
 or a
 jr z,LoadMapInfoD
 inc hl
 ld b,a
LoadMapInfoEnemyL:
 push bc
 ld a,(hl)
 inc hl
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 push hl
 call AddEnemy
 pop hl
 pop bc
 djnz LoadMapInfoEnemyL
LoadMapInfoD:
 scf
 ret

;============================================================================

; hl = address of x or y coord
CheckWarpUp:
 sub a
 or (hl)
 ret nz
 ld (hl),56
 ld a,(MapIUp)
 call LoadMapNum
 jp GrayScrollUp
 
CheckWarpDown:
 ld a,55
 cp (hl)
 ret nc
 ld (hl),0
 ld a,(MapIDown)
 call LoadMapNum
 jp GrayScrollDown
 

CheckWarpLeft:
 sub a
 or (hl)
 ret nz
 ld (hl),120
 ld a,(MapILeft)
 call LoadMapNum
 jp GrayScrollLeft

CheckWarpRight:
 ld a,119
 cp (hl)
 ret nc
 ld (hl),0
 ld a,(MapIRight)
 call LoadMapNum
 jp GrayScrollRight

;============================================================================

; hl = address of coords (x, y)
CheckTile:
 call GetTileNumCenter
 ld d,a
 ld a,(CurrTile)
 cp d
 ret z
 ld a,d
 ld (CurrTile),a

; bc = coords loaded (x, y) and centered
EnterNewTile:
 call GetTile
 ld a,(de)
 ld c,a
 ld a,(MapITel1S)
 cp c
 jr z,Tile_Warp1
 ld a,(MapITel2S)
 cp c
 jr z,Tile_Warp2
 ld a,(MapITel3S)
 cp c
 jr z,Tile_Warp3
 ld a,(MapITel4S)
 cp c
 jr z,Tile_Warp4
 ld a,(PlayerJump)
 or a
 ret nz
 ld a,HOLE
 cp c
 jr z,LinkFallInHole
 ret

LinkFallInHole:
 call HurtPlayer
 ld hl,(CurrMapEnterCoords)
 ld (PlayerY),hl
 ld hl,PlayerY
 call GetTileNumCenter
 ld (CurrTile),a
 ret

Tile_Warp1:
 ld hl,(MapITel1Y)
 ld (PlayerY),hl
 ld a,(MapITel1)
 jr Tile_Warp

Tile_Warp2:
 ld hl,(MapITel2Y)
 ld (PlayerY),hl
 ld a,(MapITel2)
 jr Tile_Warp

Tile_Warp3:
 ld hl,(MapITel3Y)
 ld (PlayerY),hl
 ld a,(MapITel3)
 jr Tile_Warp

Tile_Warp4:
 ld hl,(MapITel4Y)
 ld (PlayerY),hl
 ld a,(MapITel4)
; jr Tile_Warp

Tile_Warp:
 call LoadMapNum
 call GrayWarpScreen
 ld hl,PlayerY
 call GetTileNumCenter
 ld (CurrTile),a
 ret
 
GrayDrawMap:
 ld hl,Map
;==========================================================
; GrayDrawTileMap -- draws an 8x16 grayscale tilemap  [ACZ]
;  input: HL = pointer to tilemap to draw
;
; Buffer1, Buffer2 -- memory where map is drawn
; MapSprites       -- 8x8 non-maksed grayscale sprites
;==========================================================
GrayDrawTileMap:
 ld (_@GrayDrawMapTileP),hl
 ld hl,Buffer1
 ld de,Buffer2
 ld b,8
GrayDrawMapCol:
 push bc
 ld b,16
GrayDrawMapRow:
 push bc
 push hl
_@GrayDrawMapTileP =$+1
 ld a,($ffff)
 ld l,a
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 ld bc,MapSprites
 add hl,bc
 push hl
 pop ix
 ld b,8
 ld hl,(_@GrayDrawMapTileP)
 inc hl
 ld (_@GrayDrawMapTileP),hl
 pop hl
GrayDrawMapSpr:
 ld a,(ix+0)
 ld (hl),a
 ld a,(ix+8)
 ld (de),a
 inc ix
 push bc
 ld bc,16
 add hl,bc
 ex de,hl 
 add hl,bc
 ex de,hl
 pop bc
 djnz GrayDrawMapSpr
 ld bc,-127
 add hl,bc
 ex de,hl
 add hl,bc
 ex de,hl
 pop bc
 djnz GrayDrawMapRow
 ld bc,112
 add hl,bc
 ex de,hl
 add hl,bc
 ex de,hl
 pop bc
 djnz GrayDrawMapCol
 ret

.end
